/*****************************************************************************
 * AMOS2
 * 
 * Author: (c) 1998 Tore Risch, EDSLAB
 * $RCSfile: callout.h,v $
 * $Revision: 1.5 $ $Date: 2004/02/13 20:52:51 $
 * $State: Exp $ $Locker:  $
 *
 * Description: Amos2 C call-out interface
 ****************************************************************************/

#ifndef _callout_h_
#define _callout_h_
#include "callin.h"

typedef void (*cont_function) (bindtype,void *); /* internal continuation fn */
typedef struct a_callcontextrec
{
   bindtype env;         /* Internal ObjectLog binding environment */
   oidtype actargs;      /* Internal parameters in call */
   oidtype fno;          /* OID of called Amos function */
   oidtype extp;         /* The internal Amos object representing the predicate */
   cont_function contfn; /* Internal continuation function */
   void *xa;             /* Internal system parameters */
   int done;             /* Set to TRUE when caller does not want more data */
   void *userdata;       /* Arbitrary user data structure. Initialized to NULL */
   int traceindent;      /* Trace indentation */
} *a_callcontext;

typedef void (*external_function) (a_callcontext, a_tuple);
                                   /* External predicate prototype */
EXTERN short int extpredtype;

struct extpredcell        /* External predicates implemented in C */
{
   objtags tags;
   external_function cfn; /* C function to be called */
   oidtype name;          /* External function name */
   oidtype next;          /* extpredcells are linked together */
   void *param;           /* Arbitrary user parameter */
};

EXTERN oidtype a_extfunction(char *name,external_function fn);
                        /* Register external predicate */
EXTERN int a_emit(a_callcontext cxt, a_tuple t, int catcherror);
                 /* Emit a tuple as the result from foreign predicate */

/*** Access to external predicate internals ***/
#define a_extpredname(cxt) getstring(dr((cxt)->extp,extpredcell)->name)
         /* Picks up the name of the called predicate from a context */
EXTERN struct extpredcell *a_getextpred(char *name);
         /* Picks up external predicate object, given external predicate name */
#define a_extpredparam(cxt) (dr((cxt)->extp,extpredcell)->param)
        /* Picks up parameter of called predicate from context */
#define a_setpredparam(name,val) a_getextpred(name)->param = (val)
        /* Sets parameter field of named external predicate */

#endif

